%bcond_without check

%global goipath         github.com/junegunn/fzf
Version:                0.58.0
%global tag             %{version}

%gometa

Name:           fzf
Release:    1%{?dist}
Summary:        A command-line fuzzy finder written in Go

License:        MIT
URL:            %{gourl}
Source0:        %{gosource}
Source1:        README
Source2:        fzf-%{version}-vendor.tar.gz

Provides: bundled(golang(github.com/charlievieth/fastwalk)) = 1.0.9
Provides: bundled(golang(github.com/gdamore/encoding)) = 1.0.1
Provides: bundled(golang(github.com/gdamore/tcell/v2)) = 2.8.1
Provides: bundled(golang(github.com/junegunn/go-shellwords)) = a62c48c
Provides: bundled(golang(github.com/lucasb-eyer/go-colorful)) = 1.2.0
Provides: bundled(golang(github.com/mattn/go-isatty)) = 0.0.20
Provides: bundled(golang(github.com/mattn/go-runewidth)) = 0.0.16
Provides: bundled(golang(github.com/rivo/uniseg)) = 0.4.7
Provides: bundled(golang(golang.org/x/sys)) = 0.29.0
Provides: bundled(golang(golang.org/x/term)) = 0.28.0
Provides: bundled(golang(golang.org/x/text)) = 0.21.0

%description
fzf is a general-purpose command-line fuzzy finder.

It's an interactive Unix filter for command-line that can be used with any
list; files, command history, processes, hostnames, bookmarks, git commits,
etc.


%prep
%autosetup -a 2
cp %{SOURCE1} .

# Set up directory structure for vendor packages
mkdir -p src/$(dirname %{goipath})
ln -s $(pwd) src/%{goipath}


%build
# Create GOPATH structure and use vendor deps
export GOPATH=$(pwd)
export GO111MODULE=off
export LDFLAGS='-X main.version=%{version} -X main.revision=OpenCloudOS '
%gobuild -o %{gobuilddir}/bin/fzf %{goipath}

sed -i -e '/^#!\//, 1d' shell/completion.*
sed -i -e '1d;2i#!/bin/bash' bin/fzf-tmux


%install
install -vdm 0755 %{buildroot}%{_bindir}
install -vDpm 0755 %{gobuilddir}/bin/* %{buildroot}%{_bindir}/
install -Dpm0755 bin/fzf-tmux %{buildroot}%{_bindir}/
install -d -p %{buildroot}%{_mandir}/man1
install -Dpm0644 man/man1/*.1 %{buildroot}%{_mandir}/man1/

install -d %{buildroot}%{_datadir}/fzf

install -d %{buildroot}%{_datadir}/vim/vimfiles/plugin
install -Dpm0644 plugin/fzf.vim %{buildroot}%{_datadir}/vim/vimfiles/plugin/
install -d %{buildroot}%{_datadir}/nvim/site/plugin
install -Dpm0644 plugin/fzf.vim %{buildroot}%{_datadir}/nvim/site/plugin/

install -d %{buildroot}%{_sysconfdir}/bash_completion.d/
install -Dpm0644 shell/completion.bash %{buildroot}%{_sysconfdir}/bash_completion.d/fzf
install -d %{buildroot}%{_datadir}/zsh/site-functions
install -Dpm0644 shell/completion.zsh %{buildroot}%{_datadir}/zsh/site-functions/fzf

install -d %{buildroot}%{_datadir}/fzf/shell
install -Dpm0644 shell/key-bindings.* %{buildroot}%{_datadir}/fzf/shell/


%if %{with check}
%check
%gocheck
%endif


%files
%license LICENSE
%doc README.md README-VIM.md CHANGELOG.md README
%{_bindir}/fzf
%{_bindir}/fzf-tmux
%{_mandir}/man1/fzf.1*
%{_mandir}/man1/fzf-tmux.1*
%dir %{_datadir}/fzf
%{_datadir}/fzf/shell
%dir %{_datadir}/zsh/site-functions
%{_datadir}/zsh/site-functions/fzf
%dir %{_datadir}/vim/vimfiles/plugin
%{_datadir}/vim/vimfiles/plugin/fzf.vim
%dir %{_datadir}/nvim/site/plugin
%{_datadir}/nvim/site/plugin/fzf.vim
%{_sysconfdir}/bash_completion.d/fzf


%changelog
* Wed Apr 23 2025 Fanjun Kong <fanjunkong@tencent.com> - 0.58.0-1
- Update to 0.58.0

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.44.1-1
- initial build
